diff -urN Android_6.0.1_r11/frameworks/native/cmds/installd/commands.cpp SAMD_6.0.1_r11_20170930/frameworks/native/cmds/installd/commands.cpp
--- Android_6.0.1_r11/frameworks/native/cmds/installd/commands.cpp	2017-09-27 02:07:59.631735973 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/native/cmds/installd/commands.cpp	2017-08-07 14:11:01.498146000 +0900
@@ -29,6 +29,8 @@
 #include <sys/file.h>
 #include <unistd.h>
 
+#include <android/log.h>
+
 using android::base::StringPrintf;
 
 /* Directory records that are used in execution of commands. */
@@ -45,6 +47,7 @@
 
 int install(const char *uuid, const char *pkgname, uid_t uid, gid_t gid, const char *seinfo)
 {
+
     if ((uid < AID_SYSTEM) || (gid < AID_SYSTEM)) {
         ALOGE("invalid uid/gid: %d %d\n", uid, gid);
         return -1;
@@ -467,6 +470,26 @@
     }
 }
 
+// ADDED FOR COLLABOROID
+int move_file(const char *src, const char *dst)
+{
+/*    char src_file[PKG_PATH_MAX];
+    char dst_file[PKG_PATH_MAX];
+
+    strcpy(src_file, src);
+    strcpy(dst_file, dst);
+
+    ALOGV("move %s -> %s\n", src_file, dst_file);
+
+    if (rename(src_file, dst_file) < 0) {
+        ALOGE("Couldn't move %s: %s\n", src_file, strerror(errno));
+        return -1;
+    } else {
+        return 0;
+    }*/
+	return move_dex(src, dst, "arm");
+}
+
 int rm_dex(const char *path, const char *instruction_set)
 {
     char dex_path[PKG_PATH_MAX];
@@ -969,6 +992,231 @@
     // Do not add after dex2oat_flags, they should override others for debugging.
     argv[i] = NULL;
 
+
+    execv(DEX2OAT_BIN, (char * const *)argv);
+    ALOGE("execv(%s) failed: %s\n", DEX2OAT_BIN, strerror(errno));
+}
+
+static void run_dex2oat2(const char *dex_path, int oat_fd, const char* input_file_name,
+    const char* output_file_name, int swap_fd, const char *pkgname, const char *instruction_set,
+    bool debuggable)
+{
+    static const unsigned int MAX_INSTRUCTION_SET_LEN = 7;
+
+    if (strlen(instruction_set) >= MAX_INSTRUCTION_SET_LEN) {
+        ALOGE("Instruction set %s longer than max length of %d",
+              instruction_set, MAX_INSTRUCTION_SET_LEN);
+        return;
+    }
+
+    char prop_buf[PROPERTY_VALUE_MAX];
+    bool profiler = (property_get("dalvik.vm.profiler", prop_buf, "0") > 0) && (prop_buf[0] == '1');
+
+    char dex2oat_Xms_flag[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_Xms_flag = property_get("dalvik.vm.dex2oat-Xms", dex2oat_Xms_flag, NULL) > 0;
+
+    char dex2oat_Xmx_flag[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_Xmx_flag = property_get("dalvik.vm.dex2oat-Xmx", dex2oat_Xmx_flag, NULL) > 0;
+
+    char dex2oat_compiler_filter_flag[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_compiler_filter_flag = property_get("dalvik.vm.dex2oat-filter",
+                                                          dex2oat_compiler_filter_flag, NULL) > 0;
+
+    char dex2oat_threads_buf[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_threads_flag = false;
+    if (true) {
+        have_dex2oat_threads_flag = property_get("dalvik.vm.boot-dex2oat-threads",
+                                                 dex2oat_threads_buf,
+                                                 NULL) > 0;
+        // If there's no boot property, fall back to the image property.
+        if (!have_dex2oat_threads_flag) {
+            have_dex2oat_threads_flag = property_get("dalvik.vm.image-dex2oat-threads",
+                                                     dex2oat_threads_buf,
+                                                     NULL) > 0;
+        }
+        // If there's neither, fall back to the default property.
+    }
+    if (!have_dex2oat_threads_flag) {
+        have_dex2oat_threads_flag = property_get("dalvik.vm.dex2oat-threads",
+                                                 dex2oat_threads_buf,
+                                                 NULL) > 0;
+    }
+    char dex2oat_threads_arg[PROPERTY_VALUE_MAX + 2];
+    if (have_dex2oat_threads_flag) {
+        sprintf(dex2oat_threads_arg, "-j%s", dex2oat_threads_buf);
+    }
+
+    char dex2oat_isa_features_key[PROPERTY_KEY_MAX];
+    sprintf(dex2oat_isa_features_key, "dalvik.vm.isa.%s.features", instruction_set);
+    char dex2oat_isa_features[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_isa_features = property_get(dex2oat_isa_features_key,
+                                                  dex2oat_isa_features, NULL) > 0;
+
+    char dex2oat_isa_variant_key[PROPERTY_KEY_MAX];
+    sprintf(dex2oat_isa_variant_key, "dalvik.vm.isa.%s.variant", instruction_set);
+    char dex2oat_isa_variant[PROPERTY_VALUE_MAX];
+    bool have_dex2oat_isa_variant = property_get(dex2oat_isa_variant_key,
+                                                 dex2oat_isa_variant, NULL) > 0;
+
+    const char *dex2oat_norelocation = "-Xnorelocate";
+    bool have_dex2oat_relocation_skip_flag = false;
+
+    char dex2oat_flags[PROPERTY_VALUE_MAX];
+    int dex2oat_flags_count = property_get("dalvik.vm.dex2oat-flags",
+                                 dex2oat_flags, NULL) <= 0 ? 0 : split_count(dex2oat_flags);
+    ALOGV("dalvik.vm.dex2oat-flags=%s\n", dex2oat_flags);
+
+    // If we booting without the real /data, don't spend time compiling.
+    char vold_decrypt[PROPERTY_VALUE_MAX];
+    bool have_vold_decrypt = property_get("vold.decrypt", vold_decrypt, "") > 0;
+    bool skip_compilation = (have_vold_decrypt &&
+                             (strcmp(vold_decrypt, "trigger_restart_min_framework") == 0 ||
+                             (strcmp(vold_decrypt, "1") == 0)));
+
+    bool use_jit = check_boolean_property("debug.usejit");
+    bool generate_debug_info = check_boolean_property("debug.generate-debug-info");
+
+    static const char* DEX2OAT_BIN = "/system/bin/dex2oat";
+
+    static const char* RUNTIME_ARG = "--runtime-arg";
+
+    static const int MAX_INT_LEN = 12;      // '-'+10dig+'\0' -OR- 0x+8dig
+
+    char dex_location_arg[strlen("--dex-file=") + PKG_PATH_MAX];
+    char oat_fd_arg[strlen("--oat-fd=") + MAX_INT_LEN];
+    char oat_location_arg[strlen("--oat-location=") + PKG_PATH_MAX];
+    char instruction_set_arg[strlen("--instruction-set=") + MAX_INSTRUCTION_SET_LEN];
+    char instruction_set_variant_arg[strlen("--instruction-set-variant=") + PROPERTY_VALUE_MAX];
+    char instruction_set_features_arg[strlen("--instruction-set-features=") + PROPERTY_VALUE_MAX];
+    char profile_file_arg[strlen("--profile-file=") + PKG_PATH_MAX];
+    char top_k_profile_threshold_arg[strlen("--top-k-profile-threshold=") + PROPERTY_VALUE_MAX];
+    char dex2oat_Xms_arg[strlen("-Xms") + PROPERTY_VALUE_MAX];
+    char dex2oat_Xmx_arg[strlen("-Xmx") + PROPERTY_VALUE_MAX];
+    char dex2oat_compiler_filter_arg[strlen("--compiler-filter=") + PROPERTY_VALUE_MAX];
+    bool have_dex2oat_swap_fd = false;
+    char dex2oat_swap_fd[strlen("--swap-fd=") + MAX_INT_LEN];
+
+    sprintf(dex_location_arg, "--dex-file=%s", dex_path);
+    sprintf(oat_fd_arg, "--oat-fd=%d", oat_fd);
+    sprintf(oat_location_arg, "--oat-location=%s", output_file_name);
+    sprintf(instruction_set_arg, "--instruction-set=%s", instruction_set);
+    sprintf(instruction_set_variant_arg, "--instruction-set-variant=%s", dex2oat_isa_variant);
+    sprintf(instruction_set_features_arg, "--instruction-set-features=%s", dex2oat_isa_features);
+    if (swap_fd >= 0) {
+        have_dex2oat_swap_fd = true;
+        sprintf(dex2oat_swap_fd, "--swap-fd=%d", swap_fd);
+    }
+
+    bool have_profile_file = false;
+    bool have_top_k_profile_threshold = false;
+    if (profiler && (strcmp(pkgname, "*") != 0)) {
+        char profile_file[PKG_PATH_MAX];
+        snprintf(profile_file, sizeof(profile_file), "%s/%s",
+                 DALVIK_CACHE_PREFIX "profiles", pkgname);
+        struct stat st;
+        if ((stat(profile_file, &st) == 0) && (st.st_size > 0)) {
+            sprintf(profile_file_arg, "--profile-file=%s", profile_file);
+            have_profile_file = true;
+            if (property_get("dalvik.vm.profile.top-k-thr", prop_buf, NULL) > 0) {
+                snprintf(top_k_profile_threshold_arg, sizeof(top_k_profile_threshold_arg),
+                         "--top-k-profile-threshold=%s", prop_buf);
+                have_top_k_profile_threshold = true;
+            }
+        }
+    }
+
+    if (have_dex2oat_Xms_flag) {
+        sprintf(dex2oat_Xms_arg, "-Xms%s", dex2oat_Xms_flag);
+    }
+    if (have_dex2oat_Xmx_flag) {
+        sprintf(dex2oat_Xmx_arg, "-Xmx%s", dex2oat_Xmx_flag);
+    }
+    if (skip_compilation) {
+        strcpy(dex2oat_compiler_filter_arg, "--compiler-filter=verify-none");
+        have_dex2oat_compiler_filter_flag = true;
+        have_dex2oat_relocation_skip_flag = true;
+    } else if (use_jit) {
+        strcpy(dex2oat_compiler_filter_arg, "--compiler-filter=verify-at-runtime");
+        have_dex2oat_compiler_filter_flag = true;
+    } else if (have_dex2oat_compiler_filter_flag) {
+        sprintf(dex2oat_compiler_filter_arg, "--compiler-filter=%s", dex2oat_compiler_filter_flag);
+    }
+
+    // Check whether all apps should be compiled debuggable.
+    if (!debuggable) {
+        debuggable =
+                (property_get("dalvik.vm.always_debuggable", prop_buf, "0") > 0) &&
+                (prop_buf[0] == '1');
+    }
+
+    ALOGV("Running %s in=%s out=%s\n", DEX2OAT_BIN, input_file_name, output_file_name);
+
+    const char* argv[6  // program name, mandatory arguments and the final NULL
+                     + (have_dex2oat_isa_variant ? 1 : 0)
+                     + (have_dex2oat_isa_features ? 1 : 0)
+                     + (have_profile_file ? 1 : 0)
+                     + (have_top_k_profile_threshold ? 1 : 0)
+                     + (have_dex2oat_Xms_flag ? 2 : 0)
+                     + (have_dex2oat_Xmx_flag ? 2 : 0)
+                     + (have_dex2oat_compiler_filter_flag ? 1 : 0)
+                     + (have_dex2oat_threads_flag ? 1 : 0)
+                     + (have_dex2oat_swap_fd ? 1 : 0)
+                     + (have_dex2oat_relocation_skip_flag ? 2 : 0)
+                     + (generate_debug_info ? 1 : 0)
+                     + (debuggable ? 1 : 0)
+                     + dex2oat_flags_count];
+    int i = 0;
+    argv[i++] = DEX2OAT_BIN;
+    argv[i++] = dex_location_arg;
+    argv[i++] = oat_fd_arg;
+    argv[i++] = oat_location_arg;
+    argv[i++] = instruction_set_arg;
+    if (have_dex2oat_isa_variant) {
+        argv[i++] = instruction_set_variant_arg;
+    }
+    if (have_dex2oat_isa_features) {
+        argv[i++] = instruction_set_features_arg;
+    }
+    if (have_profile_file) {
+        argv[i++] = profile_file_arg;
+    }
+    if (have_top_k_profile_threshold) {
+        argv[i++] = top_k_profile_threshold_arg;
+    }
+    if (have_dex2oat_Xms_flag) {
+        argv[i++] = RUNTIME_ARG;
+        argv[i++] = dex2oat_Xms_arg;
+    }
+    if (have_dex2oat_Xmx_flag) {
+        argv[i++] = RUNTIME_ARG;
+        argv[i++] = dex2oat_Xmx_arg;
+    }
+    if (have_dex2oat_compiler_filter_flag) {
+        argv[i++] = dex2oat_compiler_filter_arg;
+    }
+    if (have_dex2oat_threads_flag) {
+        argv[i++] = dex2oat_threads_arg;
+    }
+    if (have_dex2oat_swap_fd) {
+        argv[i++] = dex2oat_swap_fd;
+    }
+    if (generate_debug_info) {
+        argv[i++] = "--generate-debug-info";
+    }
+    if (debuggable) {
+        argv[i++] = "--debuggable";
+    }
+    if (dex2oat_flags_count) {
+        i += split(dex2oat_flags, argv + i);
+    }
+    if (have_dex2oat_relocation_skip_flag) {
+        argv[i++] = RUNTIME_ARG;
+        argv[i++] = dex2oat_norelocation;
+    }
+    // Do not add after dex2oat_flags, they should override others for debugging.
+    argv[i] = NULL;
+
+
     execv(DEX2OAT_BIN, (char * const *)argv);
     ALOGE("execv(%s) failed: %s\n", DEX2OAT_BIN, strerror(errno));
 }
@@ -1735,6 +1983,503 @@
     return -1;
 }
 
+// ADDED FOR COLLABOROID
+int makeodex(const char *dex_path, const char *out_path, const char *pkgname)
+{
+	struct utimbuf ut;
+	struct stat dex_stat;
+	//char out_path[PKG_PATH_MAX];
+	char swap_file_name[PKG_PATH_MAX];
+	//const char *input_file;
+	int res, input_fd=-1, out_fd=-1, swap_fd=-1;
+
+	memset(&dex_stat, 0, sizeof(dex_stat));
+	stat(dex_path, &dex_stat);
+
+	input_fd = open(dex_path, O_RDONLY, 0);
+	if (input_fd < 0) {
+		ALOGE("installd cannot open '%s' for input during makeodex\n", dex_path);
+		return -1;
+	}
+
+	unlink(out_path);
+	out_fd = open(out_path, O_RDWR | O_CREAT | O_EXCL, 0644);
+	if (out_fd < 0) {
+		ALOGE("installd cannot open '%s' for output during makeodex\n", out_path);
+		goto fail;
+	}
+	if (fchmod(out_fd, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH) < 0) {
+		ALOGE("installd cannot chmod '%s' during makeodex\n", out_path);
+		goto fail;
+	}
+	if (fchown(out_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("installd cannot chown '%s' during makeodex\n", out_path);
+		goto fail;
+	}
+
+
+	// Create a swap file if necessary.
+	if (ShouldUseSwapFileForDexopt()) {
+		// Make sure there really is enough space.
+		size_t out_len = strlen(out_path);
+		if (out_len + strlen(".swap") + 1 <= PKG_PATH_MAX) {
+			strcpy(swap_file_name, out_path);
+			strcpy(swap_file_name + strlen(out_path), ".swap");
+			unlink(swap_file_name);
+			swap_fd = open(swap_file_name, O_RDWR | O_CREAT | O_EXCL, 0600);
+			if (swap_fd < 0) {
+				// Could not create swap file. Optimistically go on and hope that we can compile
+				// without it.
+				ALOGE("installd could not create '%s' for swap during makeodex\n", swap_file_name);
+			} else {
+				// Immediately unlink. We don't really want to hit flash.
+				unlink(swap_file_name);
+			}
+		} else {
+			// Swap file path is too long. Try to run without.
+			ALOGE("installd could not create swap file for path %s during dexopt\n", out_path);
+		}
+	}
+
+	ALOGV("DexInv: --- BEGIN '%s' ---\n", dex_path);
+
+	pid_t pid;
+	pid = fork();
+	if (pid == 0) {
+		if (flock(out_fd, LOCK_EX | LOCK_NB) != 0) {
+			ALOGE("flock(%s) failed: %s\n", out_path, strerror(errno));
+			exit(67);
+		}
+
+		const char *input_file_name = strrchr(dex_path, '/');
+		if (input_file_name == NULL) {
+			input_file_name = dex_path;
+		} else {
+			input_file_name++;
+		}
+		run_dex2oat2(dex_path, out_fd, input_file_name, out_path, swap_fd, pkgname,
+					"arm64", false);
+
+		exit(68);   /* only get here on exec failure */
+	} else {
+		res = wait_child(pid);
+		if (res == 0) {
+			ALOGV("DexInv: --- END '%s' (success) ---\n", dex_path);
+		} else {
+			ALOGE("DexInv: --- END '%s' --- status=0x%04x, process failed\n", dex_path, res);
+			goto fail;
+		}
+	}
+
+	ut.actime = dex_stat.st_atime;
+	ut.modtime = dex_stat.st_mtime;
+	utime(out_path, &ut);
+
+	close(out_fd);
+	close(input_fd);
+	if (swap_fd != -1) {
+		close(swap_fd);
+	}
+	return 0;
+
+fail:
+	if (out_fd >= 0) {
+		close(out_fd);
+		unlink(out_path);
+	}
+	if (input_fd >= 0) {
+		close(input_fd);
+	}
+	return -1;
+
+}
+//ADDED FOR SAMD
+static void run_aapt_package_with_assets(const char *res_path, const char *assets_path, const char *manifest_path, const char *output_apk)
+{
+    static const char *AAPT_BIN = "/system/bin/aapt";
+    static const char *MANIFEST = manifest_path;
+    static const char *FRAMEWORK_RES = "/system/framework/framework-res.apk";
+
+    ALOGD("run_aapt(package) res_path=%s assets_path=%s manifest_path=%s output_apk=%s",
+                res_path, assets_path, manifest_path, output_apk);
+
+    execl(AAPT_BIN, AAPT_BIN, "package",
+					  "-M", MANIFEST,
+					  "-S", res_path,
+					  "-A", assets_path,
+					  "-I", FRAMEWORK_RES,
+					  "-F", output_apk,
+					  "-f",
+					  (char*)NULL);
+
+    ALOGE("run_aapt(package) execl(%s) failed: %s\n", AAPT_BIN, strerror(errno));
+
+    /*unlink(output_apk);
+	int apk_fd = open(output_apk, O_RDWR | O_CREAT | O_EXCL, 0660);
+	if (apk_fd < 0) {
+		ALOGE("aapt cannot open '%s' for output: %s\n", output_apk, strerror(errno));
+	}
+	if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("aapt cannot chown '%s'\n", output_apk);
+	}
+	if (fchmod(apk_fd, 0755) < 0) {
+		ALOGE("aapt cannot fchmod '%s'\n", output_apk);
+	}
+
+	close(apk_fd);*/
+
+    execl("/system/bin/chmod", "/system/bin/chmod", "666", output_apk, (char*)NULL);
+
+    ALOGE("run_aapt(package) execl(%s) failed: %s\n", "/system/bin/chmod", strerror(errno));
+}
+
+static void run_aapt_package(const char *res_path, const char *manifest_path, const char *output_apk)
+{
+    static const char *AAPT_BIN = "/system/bin/aapt";
+    static const char *MANIFEST = manifest_path;
+    static const char *FRAMEWORK_RES = "/system/framework/framework-res.apk";
+
+    ALOGD("run_aapt(package) res_path=%s manifest_path=%s output_apk=%s",
+                res_path, manifest_path, output_apk);
+
+    execl(AAPT_BIN, AAPT_BIN, "package",
+					  "-M", MANIFEST,
+					  "-S", res_path,
+					  "-I", FRAMEWORK_RES,
+					  "-F", output_apk,
+					  "-f",
+					  (char*)NULL);
+
+    ALOGE("run_aapt(package) execl(%s) failed: %s\n", AAPT_BIN, strerror(errno));
+
+    /*unlink(output_apk);
+	int apk_fd = open(output_apk, O_RDWR | O_CREAT | O_EXCL, 0660);
+	if (apk_fd < 0) {
+		ALOGE("aapt cannot open '%s' for output: %s\n", output_apk, strerror(errno));
+	}
+	if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("aapt cannot chown '%s'\n", output_apk);
+	}
+	if (fchmod(apk_fd, 0755) < 0) {
+		ALOGE("aapt cannot fchmod '%s'\n", output_apk);
+	}
+
+	close(apk_fd);*/
+
+    execl("/system/bin/chmod", "/system/bin/chmod", "666", output_apk, (char*)NULL);
+
+    ALOGE("run_aapt(package) execl(%s) failed: %s\n", "/system/bin/chmod", strerror(errno));
+}
+
+static void run_aapt_add(int type, const char *apk_path, const char *file_path) // 1:add 2:remove
+{
+    static const char *AAPT_BIN = "/system/bin/aapt";
+
+    ALOGD("run_aapt(add) type=%d apk_path=%s file_path=%s", type, apk_path, file_path);
+
+    if(type == 1)
+    {
+		execl(AAPT_BIN, AAPT_BIN, "add",
+							"-v", "-k",
+							apk_path,
+							file_path,
+							(char*)NULL);
+
+		ALOGE("run_aapt(add) execl(%s) add failed: %s\n", AAPT_BIN, strerror(errno));
+    }
+    else if(type == 2)
+    {
+        execl(AAPT_BIN, AAPT_BIN, "remove",
+        						"-v",
+            					apk_path,
+            					file_path,
+            					(char*)NULL);
+
+        ALOGE("run_aapt(add) execl(%s) remove failed: %s\n", AAPT_BIN, strerror(errno));
+    }else{
+        execl(AAPT_BIN, AAPT_BIN, "add",
+        							"-v",
+        							apk_path,
+        							file_path,
+        							(char*)NULL);
+
+        		ALOGE("run_aapt(add) execl(%s) add failed: %s\n", AAPT_BIN, strerror(errno));
+    }
+
+    /*unlink(output_apk);
+	int apk_fd = open(output_apk, O_RDWR | O_CREAT | O_EXCL, 0660);
+	if (apk_fd < 0) {
+		ALOGE("aapt cannot open '%s' for output: %s\n", output_apk, strerror(errno));
+	}
+	if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("aapt cannot chown '%s'\n", output_apk);
+	}
+	if (fchmod(apk_fd, 0755) < 0) {
+		ALOGE("aapt cannot fchmod '%s'\n", output_apk);
+	}
+
+	close(apk_fd);*/
+
+    /*execl("/system/bin/chmod", "/system/bin/chmod", "666", output_apk, (char*)NULL);
+
+    ALOGE("3execl(%s) failed: %s\n", "/system/bin/chmod", strerror(errno));*/
+}
+//ADDED FOR SAMD
+int aapt_package_with_assets(const char *res_path, const char *assets_path, const char *manifest_path, const char *output_apk)
+{
+    ALOGD("aapt(package) res_path=%s assets_path=%s manifest_path=%s output_apk=%s",
+            res_path, assets_path, manifest_path, output_apk);
+
+    int apk_fd = -1;
+
+    static const int PARENT_READ_PIPE = 0;
+    static const int CHILD_WRITE_PIPE = 1;
+
+    // create pipes for redirecting STDERR to a buffer that can be displayed in logcat
+    int pipefd[2];
+    if (pipe(pipefd) != 0) {
+        pipefd[0] = pipefd[1] = -1;
+    }
+
+    pid_t pid = fork();
+
+    if (pid == 0) {
+
+    	run_aapt_package_with_assets(res_path, assets_path, manifest_path, output_apk);
+
+    	if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]);
+        }
+        exit(1); /* only if exec call to idmap failed */
+    } else {
+        int status, i;
+        char buffer[1024];
+        ssize_t readlen;
+
+        if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]); // close unused write end
+        }
+
+        if (pipefd[PARENT_READ_PIPE] > 0) {
+            while ((readlen = read(pipefd[PARENT_READ_PIPE], buffer, sizeof(buffer) - 1)) > 0) {
+                // in case buffer has more than one string in it, replace '\0' with '\n'
+                for (i = 0; i < readlen; i++) {
+                    if (buffer[i] == '\0') buffer[i] = '\n';
+                }
+                // null terminate buffer at readlen
+                buffer[readlen] = '\0';
+                ALOG(LOG_ERROR, "InstallTheme", "%s", buffer);
+            }
+            waitpid(pid, &status, 0);
+
+            if (pipefd[PARENT_READ_PIPE] > 0) {
+                close(pipefd[PARENT_READ_PIPE]);
+            }
+        } else {
+            status = wait_child(pid);
+        }
+
+        if (status != 0) {
+            ALOGE("aapt(package) failed, status=0x%04x\n", status);
+            goto fail;
+        }
+    }
+
+	apk_fd = open(output_apk, O_RDWR);
+	if (apk_fd < 0) {
+		ALOGE("aapt(package) cannot open '%s' for output: %s\n", output_apk, strerror(errno));
+		goto fail;
+	}
+	if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("aapt(package) cannot chown '%s'\n", output_apk);
+		goto fail;
+	}
+	if (fchmod(apk_fd, 0666) < 0) {
+		ALOGE("aapt(package) cannot fchmod '%s'\n", output_apk);
+		goto fail;
+	}
+
+	close(apk_fd);
+
+    return 0;
+fail:
+	if (apk_fd >= 0) {
+        close(apk_fd);
+        unlink(output_apk);
+    }
+    return -1;
+}
+
+int aapt_package(const char *res_path, const char *manifest_path, const char *output_apk)
+{
+    ALOGD("aapt(package) res_path=%s manifest_path=%s output_apk=%s",
+            res_path, manifest_path, output_apk);
+
+    int apk_fd = -1;
+
+    static const int PARENT_READ_PIPE = 0;
+    static const int CHILD_WRITE_PIPE = 1;
+
+    // create pipes for redirecting STDERR to a buffer that can be displayed in logcat
+    int pipefd[2];
+    if (pipe(pipefd) != 0) {
+        pipefd[0] = pipefd[1] = -1;
+    }
+
+    pid_t pid = fork();
+
+    if (pid == 0) {
+
+    	run_aapt_package(res_path, manifest_path, output_apk);
+
+    	if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]);
+        }
+        exit(1); /* only if exec call to idmap failed */
+    } else {
+        int status, i;
+        char buffer[1024];
+        ssize_t readlen;
+
+        if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]); // close unused write end
+        }
+
+        if (pipefd[PARENT_READ_PIPE] > 0) {
+            while ((readlen = read(pipefd[PARENT_READ_PIPE], buffer, sizeof(buffer) - 1)) > 0) {
+                // in case buffer has more than one string in it, replace '\0' with '\n'
+                for (i = 0; i < readlen; i++) {
+                    if (buffer[i] == '\0') buffer[i] = '\n';
+                }
+                // null terminate buffer at readlen
+                buffer[readlen] = '\0';
+                ALOG(LOG_ERROR, "InstallTheme", "%s", buffer);
+            }
+            waitpid(pid, &status, 0);
+
+            if (pipefd[PARENT_READ_PIPE] > 0) {
+                close(pipefd[PARENT_READ_PIPE]);
+            }
+        } else {
+            status = wait_child(pid);
+        }
+
+        if (status != 0) {
+            ALOGE("aapt(package) failed, status=0x%04x\n", status);
+            goto fail;
+        }
+    }
+
+	apk_fd = open(output_apk, O_RDWR);
+	if (apk_fd < 0) {
+		ALOGE("aapt(package) cannot open '%s' for output: %s\n", output_apk, strerror(errno));
+		goto fail;
+	}
+	if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+		ALOGE("aapt(package) cannot chown '%s'\n", output_apk);
+		goto fail;
+	}
+	if (fchmod(apk_fd, 0666) < 0) {
+		ALOGE("aapt(package) cannot fchmod '%s'\n", output_apk);
+		goto fail;
+	}
+
+	close(apk_fd);
+
+    return 0;
+fail:
+	if (apk_fd >= 0) {
+        close(apk_fd);
+        unlink(output_apk);
+    }
+    return -1;
+}
+
+int aapt_add(int type, const char *apk_path, const char *file_path) // type - 1:add 2:remove
+{
+    ALOGD("aapt(add) apk_path=%s file_path=%s", apk_path, file_path);
+
+    int apk_fd = -1;
+
+    static const int PARENT_READ_PIPE = 0;
+    static const int CHILD_WRITE_PIPE = 1;
+
+    // create pipes for redirecting STDERR to a buffer that can be displayed in logcat
+    int pipefd[2];
+    if (pipe(pipefd) != 0) {
+        pipefd[0] = pipefd[1] = -1;
+    }
+
+    pid_t pid = fork();
+
+    if (pid == 0) {
+    	//unlink(apk_path);
+    	apk_fd = open(apk_path, O_RDWR);
+		if (apk_fd < 0) {
+			ALOGE("aapt(add) cannot open '%s' for output: %s\n", apk_path, strerror(errno));
+			goto fail;
+		}
+		if (fchown(apk_fd, AID_SYSTEM, AID_SYSTEM) < 0) {
+			ALOGE("aapt(add) cannot chown '%s'\n", apk_path);
+			goto fail;
+		}
+		if (fchmod(apk_fd, 0666) < 0) {
+			ALOGE("aapt(add) cannot fchmod '%s'\n", apk_path);
+			goto fail;
+		}
+
+    	run_aapt_add(type, apk_path, file_path);
+
+    	close(apk_fd);
+
+    	if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]);
+        }
+        exit(1); /* only if exec call to idmap failed */
+    } else {
+        int status, i;
+        char buffer[1024];
+        ssize_t readlen;
+
+        if (pipefd[CHILD_WRITE_PIPE] > 0) {
+            close(pipefd[CHILD_WRITE_PIPE]); // close unused write end
+        }
+
+        if (pipefd[PARENT_READ_PIPE] > 0) {
+            while ((readlen = read(pipefd[PARENT_READ_PIPE], buffer, sizeof(buffer) - 1)) > 0) {
+                // in case buffer has more than one string in it, replace '\0' with '\n'
+                for (i = 0; i < readlen; i++) {
+                    if (buffer[i] == '\0') buffer[i] = '\n';
+                }
+                // null terminate buffer at readlen
+                buffer[readlen] = '\0';
+                ALOG(LOG_ERROR, "InstallTheme", "%s", buffer);
+            }
+            waitpid(pid, &status, 0);
+
+            if (pipefd[PARENT_READ_PIPE] > 0) {
+                close(pipefd[PARENT_READ_PIPE]);
+            }
+        } else {
+            status = wait_child(pid);
+        }
+
+        if (status != 0) {
+            ALOGE("aapt(add) failed, status=0x%04x\n", status);
+            goto fail;
+        }
+    }
+
+    return 0;
+fail:
+	if (apk_fd >= 0) {
+        close(apk_fd);
+        unlink(apk_path);
+    }
+    return -1;
+}
+// ADDED FOR COLLABOROID
+
 int restorecon_data(const char* uuid, const char* pkgName,
                     const char* seinfo, uid_t uid)
 {
diff -urN Android_6.0.1_r11/frameworks/native/cmds/installd/installd.cpp SAMD_6.0.1_r11_20170930/frameworks/native/cmds/installd/installd.cpp
--- Android_6.0.1_r11/frameworks/native/cmds/installd/installd.cpp	2017-09-27 02:07:59.631735973 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/native/cmds/installd/installd.cpp	2017-08-05 15:02:30.796988000 +0900
@@ -63,6 +63,12 @@
     return move_dex(arg[0], arg[1], arg[2]); /* src, dst, instruction_set */
 }
 
+// ADDED FOR COLLABOROID
+static int do_move_file(char **arg, char reply[REPLY_MAX] __unused)
+{
+    return move_file(arg[0], arg[1]); /* src, dst */
+}
+
 static int do_rm_dex(char **arg, char reply[REPLY_MAX] __unused)
 {
     return rm_dex(arg[0], arg[1]); /* pkgname, instruction_set */
@@ -161,6 +167,27 @@
     return idmap(arg[0], arg[1], atoi(arg[2]));
 }
 
+static int do_make_odex(char **arg, char reply[REPLY_MAX] __unused)
+{
+    return makeodex(arg[0], arg[1], arg[2]);
+}
+
+//AADED FOR SAMD
+static int do_aapt_package_with_assets(char **arg, char reply[REPLY_MAX] __unused)
+{
+    return aapt_package_with_assets(arg[0], arg[1], arg[2], arg[3]);
+}
+
+static int do_aapt_package(char **arg, char reply[REPLY_MAX] __unused)
+{
+    return aapt_package(arg[0], arg[1], arg[2]);
+}
+
+static int do_aapt_add(char **arg, char reply[REPLY_MAX] __unused)
+{
+    return aapt_add(atoi(arg[0]), arg[1], arg[2]);
+}
+
 static int do_restorecon_data(char **arg, char reply[REPLY_MAX] __attribute__((unused)))
 {
     return restorecon_data(parse_null(arg[0]), arg[1], arg[2], atoi(arg[3]));
@@ -197,6 +224,7 @@
     { "dexopt",               10, do_dexopt },
     { "markbootcomplete",     1, do_mark_boot_complete },
     { "movedex",              3, do_move_dex },
+    { "movefile",             2, do_move_file },
     { "rmdex",                2, do_rm_dex },
     { "remove",               3, do_remove },
     { "rename",               2, do_rename },
@@ -213,6 +241,10 @@
     { "mkuserconfig",         1, do_mk_user_config },
     { "rmuser",               2, do_rm_user },
     { "idmap",                3, do_idmap },
+    { "makeodex",             3, do_make_odex },
+    { "aaptpackage",          3, do_aapt_package },
+    { "aaptadd",              3, do_aapt_add },
+    { "aaptpackagewithassets",4, do_aapt_package_with_assets },
     { "restorecondata",       4, do_restorecon_data },
     { "createoatdir",         2, do_create_oat_dir },
     { "rmpackagedir",         1, do_rm_package_dir },
diff -urN Android_6.0.1_r11/frameworks/native/opengl/tests/testPauseResume/src/sbj/android/test/TestActivity.java SAMD_6.0.1_r11_20170930/frameworks/native/opengl/tests/testPauseResume/src/sbj/android/test/TestActivity.java
--- Android_6.0.1_r11/frameworks/native/opengl/tests/testPauseResume/src/sbj/android/test/TestActivity.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/native/opengl/tests/testPauseResume/src/sbj/android/test/TestActivity.java	2017-01-29 02:51:15.625845000 +0900
@@ -0,0 +1,64 @@
+/*
+ * Copyright (C) 2007 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package com.android.test.*
+
+import android.app.Activity;
+import android.os.Bundle;
+import android.util.Log;
+
+public class TestActivity extends Activity {
+    private final static String TAG = "TestActivity";
+    TestView mView;
+    boolean mToggle;
+    int mCount;
+    final static int PAUSE_DELAY = 100;
+    Runnable mRunnable = new Runnable() {
+        public void run() {
+        if (mToggle) {
+            Log.w(TAG, "****** step " + mCount + " resume");
+            mCount++;
+            mView.onResume();
+        } else {
+            Log.w(TAG, "step " + mCount + " pause");
+            mView.onPause();
+        }
+        mToggle = ! mToggle;
+        mView.postDelayed(mRunnable, PAUSE_DELAY);
+        }
+    };
+
+    @Override
+    protected void onCreate(Bundle icicle) {
+        super.onCreate(icicle);
+        mView = new TestView(getApplication());
+	    mView.setFocusableInTouchMode(true);
+	    setContentView(mView);
+        mView.postDelayed(mRunnable, PAUSE_DELAY);
+    }
+
+    @Override
+    protected void onPause() {
+        super.onPause();
+        mView.onPause();
+    }
+
+    @Override
+    protected void onResume() {
+        super.onResume();
+        mView.onResume();
+    }
+}
